rift.h
/*
* Software License Agreement (BSD License)
*
* Point Cloud Library (PCL) - www.pointclouds.org
* Copyright (c) 2010-2011, Willow Garage, Inc.
* Copyright (c) 2012-, Open Perception, Inc.
*
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
* * Redistributions of source code must retain the above copyright
* notice, this list of conditions and the following disclaimer.
* * Redistributions in binary form must reproduce the above
* copyright notice, this list of conditions and the following
* disclaimer in the documentation and/or other materials provided
* with the distribution.
* * Neither the name of the copyright holder(s) nor the names of its
* contributors may be used to endorse or promote products derived
* from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
* FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
* COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
* LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
* ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
* POSSIBILITY OF SUCH DAMAGE.
*
* $Id$
*
*/
#pragma once
#include <pcl/features/feature.h>
namespace pcl
{
/** \brief RIFTEstimation estimates the Rotation Invariant Feature Transform descriptors for a given point cloud
* dataset containing points and intensity. For more information about the RIFT descriptor, see:
*
* Svetlana Lazebnik, Cordelia Schmid, and Jean Ponce.
* A sparse texture representation using local affine regions.
* In IEEE Transactions on Pattern Analysis and Machine Intelligence, volume 27, pages 1265-1278, August 2005.
*
* \author Michael Dixon
* \ingroup features
*/
template <typename PointInT, typename GradientT, typename PointOutT>
class RIFTEstimation: public Feature<PointInT, PointOutT>
{
public:
using Feature<PointInT, PointOutT>::feature_name_;
using Feature<PointInT, PointOutT>::getClassName;
using Feature<PointInT, PointOutT>::surface_;
using Feature<PointInT, PointOutT>::indices_;
using Feature<PointInT, PointOutT>::tree_;
using Feature<PointInT, PointOutT>::search_radius_;
using PointCloudIn = pcl::PointCloud<PointInT>;
using PointCloudOut = typename Feature<PointInT, PointOutT>::PointCloudOut;
using PointCloudGradient = pcl::PointCloud<GradientT>;
using PointCloudGradientPtr = typename PointCloudGradient::Ptr;
using PointCloudGradientConstPtr = typename PointCloudGradient::ConstPtr;
using Ptr = shared_ptr<RIFTEstimation<PointInT, GradientT, PointOutT> >;
using ConstPtr = shared_ptr<const RIFTEstimation<PointInT, GradientT, PointOutT> >;
/** \brief Empty constructor. */
RIFTEstimation () : gradient_ (), nr_distance_bins_ (4), nr_gradient_bins_ (8)
{
feature_name_ = "RIFTEstimation";
};
/** \brief Provide a pointer to the input gradient data
* \param[in] gradient a pointer to the input gradient data
*/
inline void
setInputGradient (const PointCloudGradientConstPtr &gradient) { gradient_ = gradient; };
/** \brief Returns a shared pointer to the input gradient data */
inline PointCloudGradientConstPtr
getInputGradient () const { return (gradient_); };
/** \brief Set the number of bins to use in the distance dimension of the RIFT descriptor
* \param[in] nr_distance_bins the number of bins to use in the distance dimension of the RIFT descriptor
*/
inline void
setNrDistanceBins (int nr_distance_bins) { nr_distance_bins_ = nr_distance_bins; };
/** \brief Returns the number of bins in the distance dimension of the RIFT descriptor. */
inline int
getNrDistanceBins () const { return (nr_distance_bins_); };
/** \brief Set the number of bins to use in the gradient orientation dimension of the RIFT descriptor
* \param[in] nr_gradient_bins the number of bins to use in the gradient orientation dimension of the RIFT descriptor
*/
inline void
setNrGradientBins (int nr_gradient_bins) { nr_gradient_bins_ = nr_gradient_bins; };
/** \brief Returns the number of bins in the gradient orientation dimension of the RIFT descriptor. */
inline int
getNrGradientBins () const { return (nr_gradient_bins_); };
/** \brief Estimate the Rotation Invariant Feature Transform (RIFT) descriptor for a given point based on its
* spatial neighborhood of 3D points and the corresponding intensity gradient vector field
* \param[in] cloud the dataset containing the Cartesian coordinates of the points
* \param[in] gradient the dataset containing the intensity gradient at each point in \a cloud
* \param[in] p_idx the index of the query point in \a cloud (i.e. the center of the neighborhood)
* \param[in] radius the radius of the RIFT feature
* \param[in] indices the indices of the points that comprise \a p_idx's neighborhood in \a cloud
* \param[in] squared_distances the squared distances from the query point to each point in the neighborhood
* \param[out] rift_descriptor the resultant RIFT descriptor
*/
void
computeRIFT (const PointCloudIn &cloud, const PointCloudGradient &gradient, int p_idx, float radius,
const pcl::Indices &indices, const std::vector<float> &squared_distances,
Eigen::MatrixXf &rift_descriptor);
protected:
/** \brief Estimate the Rotation Invariant Feature Transform (RIFT) descriptors at a set of points given by
* <setInputCloud (), setIndices ()> using the surface in setSearchSurface (), the gradient in
* setInputGradient (), and the spatial locator in setSearchMethod ()
* \param[out] output the resultant point cloud model dataset that contains the RIFT feature estimates
*/
void
computeFeature (PointCloudOut &output) override;
/** \brief The intensity gradient of the input point cloud data*/
PointCloudGradientConstPtr gradient_;
/** \brief The number of distance bins in the descriptor. */
int nr_distance_bins_;
/** \brief The number of gradient orientation bins in the descriptor. */
int nr_gradient_bins_;
};
}
#ifdef PCL_NO_PRECOMPILE
#include <pcl/features/impl/rift.hpp>
#endif
pcl::Feature
Feature represents the base feature class.
Definition: feature.h:107
pcl::Feature::Ptr
shared_ptr< Feature< PointInT, PointOutT > > Ptr
Definition: feature.h:114
pcl::Feature::feature_name_
std::string feature_name_
The feature name.
Definition: feature.h:223
pcl::Feature::ConstPtr
shared_ptr< const Feature< PointInT, PointOutT > > ConstPtr
Definition: feature.h:115
pcl::PointCloud< PointInT >
pcl::PointCloud::Ptr
shared_ptr< PointCloud< PointT > > Ptr
Definition: point_cloud.h:413
pcl::PointCloud::ConstPtr
shared_ptr< const PointCloud< PointT > > ConstPtr
Definition: point_cloud.h:414
pcl::RIFTEstimation
RIFTEstimation estimates the Rotation Invariant Feature Transform descriptors for a given point cloud...
Definition: rift.h:60
pcl::RIFTEstimation::PointCloudIn
pcl::PointCloud< PointInT > PointCloudIn
Definition: rift.h:71
pcl::RIFTEstimation::setNrGradientBins
void setNrGradientBins(int nr_gradient_bins)
Set the number of bins to use in the gradient orientation dimension of the RIFT descriptor.
Definition: rift.h:112
pcl::RIFTEstimation::computeFeature
void computeFeature(PointCloudOut &output) override
Estimate the Rotation Invariant Feature Transform (RIFT) descriptors at a set of points given by <set...
Definition: rift.hpp:113
pcl::RIFTEstimation::RIFTEstimation
RIFTEstimation()
Empty constructor.
Definition: rift.h:83
pcl::RIFTEstimation::PointCloudGradient
pcl::PointCloud< GradientT > PointCloudGradient
Definition: rift.h:74
pcl::RIFTEstimation::nr_distance_bins_
int nr_distance_bins_
The number of distance bins in the descriptor.
Definition: rift.h:147
pcl::RIFTEstimation::gradient_
PointCloudGradientConstPtr gradient_
The intensity gradient of the input point cloud data.
Definition: rift.h:144
pcl::RIFTEstimation::setNrDistanceBins
void setNrDistanceBins(int nr_distance_bins)
Set the number of bins to use in the distance dimension of the RIFT descriptor.
Definition: rift.h:102
pcl::RIFTEstimation::getNrDistanceBins
int getNrDistanceBins() const
Returns the number of bins in the distance dimension of the RIFT descriptor.
Definition: rift.h:106
pcl::RIFTEstimation::setInputGradient
void setInputGradient(const PointCloudGradientConstPtr &gradient)
Provide a pointer to the input gradient data.
Definition: rift.h:92
pcl::RIFTEstimation::PointCloudGradientConstPtr
typename PointCloudGradient::ConstPtr PointCloudGradientConstPtr
Definition: rift.h:76
pcl::RIFTEstimation::nr_gradient_bins_
int nr_gradient_bins_
The number of gradient orientation bins in the descriptor.
Definition: rift.h:150
pcl::RIFTEstimation::computeRIFT
void computeRIFT(const PointCloudIn &cloud, const PointCloudGradient &gradient, int p_idx, float radius, const pcl::Indices &indices, const std::vector< float > &squared_distances, Eigen::MatrixXf &rift_descriptor)
Estimate the Rotation Invariant Feature Transform (RIFT) descriptor for a given point based on its sp...
Definition: rift.hpp:48
pcl::RIFTEstimation::PointCloudGradientPtr
typename PointCloudGradient::Ptr PointCloudGradientPtr
Definition: rift.h:75
pcl::RIFTEstimation::getInputGradient
PointCloudGradientConstPtr getInputGradient() const
Returns a shared pointer to the input gradient data.
Definition: rift.h:96
pcl::RIFTEstimation::PointCloudOut
typename Feature< PointInT, PointOutT >::PointCloudOut PointCloudOut
Definition: rift.h:72
pcl::RIFTEstimation::getNrGradientBins
int getNrGradientBins() const
Returns the number of bins in the gradient orientation dimension of the RIFT descriptor.
Definition: rift.h:116
pcl
Definition: convolution.h:46
pcl::Indices
IndicesAllocator<> Indices
Type used for indices in PCL.
Definition: types.h:133